module Expr1 where

import Parser
import Data.Char 

data Expr   = Plus  Expr Expr
            | Times Expr Expr
            | Var    String
            deriving (Eq, Show)

-- Variable ::= Char^+
-- Factor ::= Variable | '(' Expr ')'
pFactor :: Parse Char Expr
pFactor = some (spot isAlpha) `use` Var
        `alt` token '(' *> pExpr >* token ')'

-- Term ::= Factor '*' Term  | Factor
pTerm :: Parse Char Expr
pTerm = 
  pFactor >* token '*' >*> pTerm `use2` Times
  `alt` pFactor 

-- Expr ::= Term '+' Expr | Term
pExpr :: Parse Char Expr
pExpr = pTerm >* token '+' >*> pExpr `use2` Plus
      `alt` pTerm 

-- Hauptfunktion
parseExpr :: String-> Expr
parseExpr i = 
  case parse pExpr (filter (not.isSpace) i) of 
    Right e ->  e
    Left err -> error err
